// -*- C++ -*-

// Base non-dir inode
// This just exists to serialize thread access to an inode

// (C) Copyright 1994 Jeremy Fitzhardinge <jeremy@sw.oz.au>
// This code is distributed under the terms of the
// GNU General Public Licence.  See COPYING for more details.

#ifndef _INO_H_
#define _INO_H_

#pragma interface

#include <SimpleInode.h>
#include <LWP.h>

class ftpfs;

class ino : public SimpleInode
{
	Semaphore sem;
		
	void beforeop(up_ops);
	void afterop(up_ops);
	
	int do_iput(const up_preamble &, upp_repl &, const upp_iput_s &);

	void decref();
public:
	ino(ftpfs &);
};

#endif /* _INO_H_ */
