// -*- C++ -*-

// A simple inode with some very basic operations implemented

#ifndef _SIMPLEINODE_H_
#define _SIMPLEINODE_H_

#pragma interface

#include <Inode.h>

class SimpleInode: public Inode
{
public:
	virtual void iread(up_inode &);
	virtual void iwrite(const up_inode &);

	int do_iwrite(const up_preamble &, upp_repl &,
		      const upp_iwrite_s &arg);
	int do_iread(const up_preamble &, upp_repl &,
		     const upp_iread_s &, upp_iread_r &);
	int do_notify_change(const up_preamble &, upp_repl &,
			     const upp_notify_change_s &);
	int do_open(const up_preamble &, upp_repl &,
		    const upp_open_s &, upp_open_r &);
	int do_close(const up_preamble &, upp_repl &,
		     const upp_close_s &);
	int do_permission(const up_preamble &, upp_repl &,
			  const upp_permission_s &);
	int do_iput(const up_preamble &, upp_repl &,
		    const upp_iput_s &);
	
	SimpleInode(Filesystem &, Handle);
};

#endif /* _SIMPLEINODE_H_ */
